# Tests by default. No tests: rpm -ba --define 'dotests 0' file*.spec
%{!?dotests: %define dotests 1}
Summary: A utility for determining file types
Name: file
Version: 5.36
Release: 1
License: BSD
Group: Applications/File
Source0: ftp://ftp.astron.com/pub/file/file-%{version}.tar.gz
#Source1: %{name}-%{version}-%{release}.build.log
Patch0: %{name}-%{version}-rpmbuild-hang-fix.patch
Patch1: %{name}-%{version}-strip.patch
URL: http://www.darwinsys.com/file/

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: zlib-devel
AutoReqProv:    no

%define _libdir64 %{_prefix}/lib64

Requires: %{name}-libs = %{version}-%{release}

%description
The file command is used to identify a particular file according to the
type of data contained by the file.  File can identify many different
file types, including ELF binaries, system libraries, RPM packages, and
different graphics formats.

You should install the file package, since the file command is such a
useful utility.
%package libs
Summary: Libraries for applications using libmagic
Group:   Applications/File
BuildRequires: libgcc >= 6.3.0-1
Requires: libgcc >= 6.3.0-1
Requires: zlib >= 1.2.11

%description libs

Libraries for applications using libmagic.

The library is available as 32-bit and 64-bit.


%package devel
Summary:  Libraries and header files for file development
Group:    Applications/File
Requires: %{name} = %{version}-%{release}

%description devel
The file-devel package contains the header files and libmagic library
necessary for developing programs using libmagic.

%prep
# Don't use -b -- it will lead to poblems when compiling magic file
%setup -q
%patch0 -p0
%patch1 -p0
rm -rf /tmp/%{name}-%{version}-32bit
mkdir  /tmp/%{name}-%{version}-32bit
mv *   /tmp/%{name}-%{version}-32bit
mkdir 32bit
mv     /tmp/%{name}-%{version}-32bit/* 32bit
rm -rf /tmp/%{name}-%{version}-32bit
mkdir 64bit
cp -rp 32bit/* 64bit/

%build
# setup environment for 32-bit and 64-bit
export AR="/usr/bin/ar -X32_64"        
export NM="/usr/bin/nm -X32_64" 
export CC="/opt/freeware/bin/gcc"
export CXX="/opt/freeware/bin/g++"

# work around strange libtool error on AIX6.1, see details at:
# https://www.ibm.com/developerworks/forums/thread.jspa?messageID=14145662
export RM="/usr/bin/rm -f"
# first build the 64-bit version
cd 64bit
export OBJECT_MODE=64 
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib "
CFLAGS="-maix64 -I/opt/freeware/include/ -D_ALL_SOURCE -D_FILE_OFFSET_BITS=64 -O2"  \
CPPFLAGS='-I/opt/freeware/include ' \
./configure --prefix=%{_prefix} \
	   --mandir=%{_mandir} \
           --libdir=%{_libdir64} \
	   --enable-fsect-man5 \
	   --disable-silent-rules
gmake "V=1"

cp src/.libs/libmagic.so.1 ../32bit 

#make distclean

if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

# now build the 32-bit version
cd ../32bit
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
CFLAGS="-maix32 -I/opt/freeware/include/ -D_ALL_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -O2" \
CPPFLAGS='-I/opt/freeware/include ' \
./configure --prefix=%{_prefix} \
	   --mandir=%{_mandir} \
	   --libdir=%{_libdir} \
           --enable-fsect-man5 \
	   --disable-silent-rules
gmake "V=1"

# add the 64-bit shared objects to the shared library containing already the
# 32-bit shared objects
# avoid "busy" error messages...
slibclean
${AR} -q  src/.libs/libmagic.a ./libmagic.so.1

if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
export OBJECT_MODE=64 
cd 64bit
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in *
  do
    mv ${f} ${f}_64
  done
)

cat magic/Magdir/* > ${RPM_BUILD_ROOT}%{_datadir}/misc/magic
ln -s misc/magic ${RPM_BUILD_ROOT}%{_datadir}/magic
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/%{name}
ln -s ../magic ${RPM_BUILD_ROOT}%{_datadir}/%{name}/magic

export OBJECT_MODE=32
cd ../32bit
gmake DESTDIR=${RPM_BUILD_ROOT} install
/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :
(
    cd  ${RPM_BUILD_ROOT}%{_bindir}
    for f in $(ls -1| grep -v -e _32 -e _64)
    do
        mv $f "$f"_32
        ln -sf "$f"_64 $f
    done
)
(
  cd ${RPM_BUILD_ROOT}
  for dir in include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
  mkdir -p usr/linux/bin
  cd usr/linux/bin
  ln -sf ../../..%{_bindir}/* .
)

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,system,-)
%doc 32bit/COPYING 32bit/ChangeLog 32bit/README
%{_bindir}/*
%{_mandir}/man1/*
/usr/linux/bin/*

%files libs
%defattr(-,root,system,-)
%{_libdir}/*.a
%{_libdir}64/*.a
%{_datadir}/magic*
%{_mandir}/man5/*
%{_datadir}/%{name}
%{_datadir}/misc/*
/usr/lib/*.a
/usr/lib64/*.a

%files devel
%defattr(-,root,system,-)
%{_includedir}/*
%{_mandir}/man3/*
/usr/include/*

%changelog
* Mon May 06 2019 Reshma V Kumar <reskumar@in.ibm.com>5.36-1
- Updated to fix CVE-2019-8907,CVE-2019-8904,CVE-2019-8906,CVE-2019-8905

* Wed Dec 26 2018 Reshma V Kumar <reskumar@in.ibm.com>5.32-2
- Rebuild with rpmbuild-hang-fix.patch

* Sat Feb 17 2018 Reshma V Kumar <reskumar@in.ibm.com>5.32-1
- Update to latest version

* Thu Mar 17 2016 Sangamesh Mallayya <smallayy@in.ibm.com> 5.12-2
- Update to 5.12 for AIX Toolbox.

* Thu Jul 04 2013 Gerard Visiedo <gerard.visiedo@bull.net> 5.12-2
-  update to version 5.12. on Aix5.3

* Tue Feb 12 2013 Gerard Visiedo <gerard.visiedo@bull.net> 5.12-1
- update to version 5.12. This version is mandatory for rpm manager 4.9.1.3

* Thu Mar 29 2012 Patricia Cugny <patricia.cugny@bull.net>  5.11-1
- update to version 5.11

* Fri Mar 13 2009 Jean Noel Cordenner <jean-noel.cordenner@bull.net> 5.00-1
- port to AIX



